package org.antlr.codegen;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.ArrayList;
import java.util.List;
import org.antlr.codegen.CodeGenerator;
import org.antlr.codegen.Target;
import org.antlr.runtime.Token;
import org.antlr.tool.Grammar;

public class Python3Target extends Target {
  public boolean useBaseTemplatesForSynPredFragments() {
    return false;
  }
  
  public String getTokenTypeAsTargetLabel(CodeGenerator generator, int ttype) {
    if (ttype >= 0 && ttype <= 3)
      return String.valueOf(ttype); 
    String name = generator.grammar.getTokenDisplayName(ttype);
    if (name.charAt(0) == '\'')
      return String.valueOf(ttype); 
    return name;
  }
  
  public String getTargetCharLiteralFromANTLRCharLiteral(CodeGenerator generator, String literal) {
    int c = Grammar.getCharValueFromGrammarCharLiteral(literal);
    return String.valueOf(c);
  }
  
  private List<String> splitLines(String text) {
    ArrayList<String> l = new ArrayList<String>();
    int idx = 0;
    while (true) {
      int eol = text.indexOf("\n", idx);
      if (eol == -1) {
        l.add(text.substring(idx));
        break;
      } 
      l.add(text.substring(idx, eol + 1));
      idx = eol + 1;
    } 
    return l;
  }
  
  public List<Object> postProcessAction(List<Object> chunks, Token actionToken) {
    List<Object> nChunks = new ArrayList();
    for (int i = 0; i < chunks.size(); i++) {
      Object chunk = chunks.get(i);
      if (chunk instanceof String) {
        String text = (String)chunks.get(i);
        if (nChunks.isEmpty() && actionToken.getCharPositionInLine() >= 0) {
          String ws = "";
          for (int k = 0; k < actionToken.getCharPositionInLine(); k++)
            ws = ws + " "; 
          text = ws + text;
        } 
        nChunks.addAll(splitLines(text));
      } else {
        if (nChunks.isEmpty() && actionToken.getCharPositionInLine() >= 0) {
          String ws = "";
          for (int k = 0; k <= actionToken.getCharPositionInLine(); k++)
            ws = ws + " "; 
          nChunks.add(ws);
        } 
        nChunks.add(chunk);
      } 
    } 
    int lineNo = actionToken.getLine();
    int col = 0;
    int lastChunk = nChunks.size() - 1;
    while (lastChunk > 0 && nChunks.get(lastChunk) instanceof String && ((String)nChunks.get(lastChunk)).trim().length() == 0)
      lastChunk--; 
    int firstChunk = 0;
    while (firstChunk <= lastChunk && nChunks.get(firstChunk) instanceof String && ((String)nChunks.get(firstChunk)).trim().length() == 0 && ((String)nChunks.get(firstChunk)).endsWith("\n")) {
      lineNo++;
      firstChunk++;
    } 
    int indent = -1;
    for (int j = firstChunk; j <= lastChunk; j++) {
      Object chunk = nChunks.get(j);
      if (chunk instanceof String) {
        String text = (String)chunk;
        if (col == 0) {
          if (indent == -1) {
            indent = 0;
            for (int k = 0; k < text.length() && 
              Character.isWhitespace(text.charAt(k)); k++)
              indent++; 
          } 
          if (text.length() >= indent) {
            int k;
            for (k = 0; k < indent; k++) {
              if (!Character.isWhitespace(text.charAt(k))) {
                System.err.println("Warning: badly indented line " + lineNo + " in action:");
                System.err.println(text);
                break;
              } 
            } 
            nChunks.set(j, text.substring(k));
          } else if (text.trim().length() > 0) {
            System.err.println("Warning: badly indented line " + lineNo + " in action:");
            System.err.println(text);
          } 
        } 
        if (text.endsWith("\n")) {
          lineNo++;
          col = 0;
        } else {
          col += text.length();
        } 
      } else {
        col++;
      } 
    } 
    return nChunks;
  }
}
